var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import React, { useState } from 'react';
import { Icon } from "../elements";
import { Dropdown } from "../inputs";
export var AppDropdown = function (_a) {
    var name = _a.name, onClose = _a.onClose, options = _a.options, version = _a.version;
    var _b = useState(false), open = _b[0], setOpen = _b[1];
    var toggle = function () { return setOpen(function (prevState) { return !prevState; }); };
    var trigger = function () { return (React.createElement(Icon, { name: open ? 'times' : 'bars', onClick: toggle, size: "medium" })); };
    var _options = __spreadArrays((options || []), [
        {
            label: "Close " + name,
            onClick: function () {
                setOpen(false);
                if (onClose) {
                    onClose();
                }
            },
            divider: true,
        },
        {
            label: "Version " + version,
            onClick: function (e) { return e.stopPropagation(); },
            disabled: true,
        },
    ]);
    var items = _options.map(function (props, idx) {
        var _a = props, label = _a.label, rest = __rest(_a, ["label"]);
        return (React.createElement(Dropdown.Item, __assign({ key: label + "-" + idx }, rest),
            React.createElement("span", null, label)));
    });
    return (React.createElement(Dropdown, { open: open, onClick: toggle, trigger: trigger },
        React.createElement(Dropdown.ListWrapper, { direction: "left", autoWidth: true }, items)));
};
