import { OGIT } from '@hiro-graph/client';
import { ContributorColumns, ContributorStats, OgitSession, SessionData } from './types';
export declare const isIeBrowser: () => true | RegExpMatchArray | null;
interface UserProfile extends OGIT.SafeNode {
    'ogit/Auth/Account/displayName': string;
    '/roles'?: string;
}
interface UserAccount extends OGIT.SafeNode {
    'ogit/email': string;
    'ogit/name': string;
    'ogit/status': string;
}
interface UserFromOgit {
    account: UserAccount;
    profile: UserProfile;
    avatar: string;
}
export declare const userFromOgit: (raw: UserFromOgit) => {
    id: string;
    name: string;
    status: string;
    email: string;
    roles: string | undefined;
    avatar: string;
};
export declare const sessionFromOgit: (raw: OgitSession) => SessionData;
export declare const getContributorColumns: ({ contributors, maxPerColumn, graphUrl, }: {
    contributors: ContributorStats[];
    maxPerColumn: number;
    graphUrl: string;
}) => ContributorColumns;
export declare const formatNumber: (n: number) => string;
export {};
