var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import styled, { css } from 'styled-components';
import cx from 'clsx';
import defaultTheme from "../../../theme";
import { clickable } from "../../../utils";
var SCALE = {
    mini: 8,
    tiny: 12,
    small: 14,
    medium: 16,
    large: 18,
    big: 20,
    huge: 24,
    massive: 32,
};
var colors = function (_a) {
    var inverted = _a.inverted, color = _a.color, theme = _a.theme, bordered = _a.bordered, inheritColor = _a.inheritColor;
    if (inheritColor) {
        return null;
    }
    if (!inverted) {
        return {
            color: color
                ? theme.colors[color].default
                : theme.colors.primaryText.default,
            border: bordered ? "1px solid " + theme.greyscale.medium : undefined,
        };
    }
    return {
        color: theme.colors.white.default,
        backgroundColor: color
            ? theme.colors[color].default
            : theme.colors.primaryText.default,
    };
};
var floating = function (_a) {
    var floating = _a.floating;
    if (!floating) {
        return null;
    }
    return {
        transform: "translateX(" + (floating === 'left' ? '-' : '') + "0.3em) translateY(-0.75em)",
    };
};
var floated = function (_a) {
    var _b;
    var floated = _a.floated;
    return floated
        ? (_b = {},
            _b[floated === 'right' ? 'marginLeft' : 'marginRight'] = 'auto',
            _b.display = 'block',
            _b) : null;
};
var actions = function (props) {
    if (!props.onClick && !props.onMouseOver) {
        return null;
    }
    if (props.bordered || props.circular) {
        if (props.onMouseOver) {
            return {
                cursor: 'pointer',
                '&:hover, &:focus': {
                    borderColor: props.bordered
                        ? props.theme.colors.primary.default
                        : undefined,
                },
            };
        }
        return clickable(props);
    }
    return {
        cursor: 'pointer',
    };
};
var IconWrapper = styled.i.withConfig({ displayName: "IconWrapper", componentId: "sc-szhkjl" })(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  box-sizing:border-box;\n  position: relative;\n\n  ", ";\n\n  margin: ", ";\n  font-size: ", ";\n  border-radius: ", ";\n\n  ", "\n  ", "\n  ", "\n  ", "\n"], ["\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  box-sizing:border-box;\n  position: relative;\n\n  ",
    ";\n\n  margin: ", ";\n  font-size: ", ";\n  border-radius: ", ";\n\n  ", "\n  ", "\n  ", "\n  ", "\n"])), function (_a) {
    var bordered = _a.bordered, circular = _a.circular;
    return bordered || circular
        ? css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n          width: 1.75em;\n          height: 1.75em;\n        "], ["\n          width: 1.75em;\n          height: 1.75em;\n        "]))) : css(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n          width: 1em;\n          height: 1em;\n          padding: 0;\n        "], ["\n          width: 1em;\n          height: 1em;\n          padding: 0;\n        "])));
}, function (_a) {
    var fitted = _a.fitted;
    return (fitted ? null : '0 0.5rem 0 0.5rem');
}, function (_a) {
    var size = _a.size;
    return (size ? SCALE[size] + "px" : null);
}, function (_a) {
    var circular = _a.circular;
    return (circular ? '50%' : null);
}, colors, floating, floated, actions);
IconWrapper.defaultProps = {
    theme: defaultTheme,
    size: 'large',
};
export var Icon = styled(function (_a) {
    var _b;
    var regular = _a.regular, className = _a.className, theme = _a.theme, name = _a.name, loading = _a.loading, rotate = _a.rotate, rest = __rest(_a, ["regular", "className", "theme", "name", "loading", "rotate"]);
    var cs = cx('fa-fw', (_b = {},
        _b["fa fa-" + name] = !regular && name,
        _b["far fa-" + name] = regular && name,
        _b['fa-spin'] = loading,
        _b['fa-rotate-90'] = rotate,
        _b));
    return (React.createElement(IconWrapper, __assign({}, rest, { className: className }),
        React.createElement("i", { className: cs })));
}).withConfig({ displayName: "Icon", componentId: "sc-ucm34l" })({
    '& > i': {
        display: 'inline-block',
        lineHeight: '1em',
        boxSizing: 'border-box',
        margin: 0,
        fontSize: '1em',
        transition: '0.2s transform',
    },
});
Icon.defaultProps = {
    theme: defaultTheme,
    size: 'medium',
};
var templateObject_1, templateObject_2, templateObject_3;
