import React from 'react';
import { TableBody } from '../Table';
import { useInfiniteScroll } from './useInfiniteScroll';
import { RootFlexContainer, Wrapper, DefaultOutsideLoading } from './styles';
import { DefaultLoading } from './DefaultLoading';
import { DeafultTableLoadMore } from './DefaultLoadMore';
export var LazyTable = function (_a) {
    var hasNextPage = _a.hasNextPage, _b = _a.items, items = _b === void 0 ? [] : _b, loading = _a.loading, loadNextPage = _a.loadNextPage, isLoaded = _a.isLoaded, threshold = _a.threshold, registerScrollableList = _a.registerScrollableList, _c = _a.renderRoot, Root = _c === void 0 ? RootFlexContainer : _c, Table = _a.renderTable, Header = _a.renderHeader, renderRow = _a.renderRow, _d = _a.renderLoadingIndicator, LoadingIndicator = _d === void 0 ? DefaultLoading : _d, _e = _a.renderLoadMore, LoadMore = _e === void 0 ? DeafultTableLoadMore : _e, _f = _a.renderOutsideLoading, OutsideLoading = _f === void 0 ? DefaultOutsideLoading : _f, withPrefetchedData = _a.withPrefetchedData;
    var _g = useInfiniteScroll({
        loading: loading,
        hasNextPage: hasNextPage,
        itemsLength: (items === null || items === void 0 ? void 0 : items.length) || 0,
        isLoaded: isLoaded,
        onLoadMore: loadNextPage,
        registerScrollableList: registerScrollableList,
        threshold: threshold,
        withPrefetchedData: withPrefetchedData,
    }), infiniteRef = _g.ref, scrollbarWidth = _g.scrollbarWidth, showLoadMore = _g.showLoadMore, tableMaxHeight = _g.tableMaxHeight;
    return (React.createElement(Root, null,
        React.createElement(Wrapper, { scrollbarWidth: scrollbarWidth },
            React.createElement(Table, null,
                React.createElement(Header, null),
                React.createElement(TableBody, { ref: infiniteRef, maxHeight: tableMaxHeight, tabIndex: 0 }, items === null || items === void 0 ? void 0 : items.map(renderRow))),
            React.createElement(OutsideLoading, null,
                showLoadMore && React.createElement(LoadMore, { loadNextPage: loadNextPage }),
                loading && React.createElement(LoadingIndicator, null)))));
};
