import React, { RefObject } from 'react';
import { HiroColors } from "../../../types";
export interface DropdownProps {
    trigger?: () => React.ReactNode;
    className?: string;
    ref?: RefObject<HTMLDivElement>;
    fluid?: boolean;
    open: boolean;
    onClick?: () => void;
    dropup?: boolean;
    color?: HiroColors;
    compact?: boolean;
    inverted?: boolean;
    text?: string;
    disabled?: boolean;
    placeholder?: string;
}
export interface DropdownSubComponents {
    ListWrapper: React.FC<DropdownListWrapperProps>;
    Trigger: React.FC<DropdownProps>;
    Divider: React.FC;
    Item: React.FC<DropdownItemProps>;
    Checkbox: React.FC<{
        checked?: boolean;
    }>;
}
export interface DropdownTriggerProps {
    open: boolean;
    onClick?: () => void;
    dropup?: boolean;
    color?: HiroColors;
    compact?: boolean;
    inverted?: boolean;
    text?: string;
    disabled?: boolean;
    placeholder?: string;
    fluid?: boolean;
}
export interface DropdownListWrapperProps {
    color?: HiroColors;
    maxHeight?: string;
    direction?: 'left' | 'right';
    rounded?: boolean;
    dropup?: boolean;
    autoWidth?: boolean;
    offset?: string;
}
export interface DropdownItemProps extends Omit<React.HTMLProps<HTMLDivElement>, 'as' | 'ref' | 'label'> {
    active?: boolean;
    autoHeight?: boolean;
    value?: any;
    divider?: boolean;
    disabled?: boolean;
    label?: string;
    onClick?: (e: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
}
